Index: issm/trunk/src/c/modules/VecExtrudex/VecExtrudex.cpp
===================================================================
--- issm/trunk/src/c/modules/VecExtrudex/VecExtrudex.cpp	(revision 4055)
+++ issm/trunk/src/c/modules/VecExtrudex/VecExtrudex.cpp	(revision 4055)
@@ -0,0 +1,56 @@
+/*!\file VecExtrudex
+ * \brief: vertical velocity extrusion
+ */
+
+#include "./VecExtrudex.h"
+
+#include "../../shared/shared.h"
+#include "../../include/include.h"
+#include "../../toolkits/toolkits.h"
+#include "../../EnumDefinitions/EnumDefinitions.h"
+
+void VecExtrudex( Vec vector, DataSet* elements,DataSet* nodes, DataSet* vertices, DataSet* loads, DataSet* materials, Parameters* parameters,int collapse){
+
+	double* vector_serial=NULL;
+	int i;
+	Element* element=NULL;
+	Penta*   penta=NULL;
+	Node*    node=NULL;
+
+	/*First, get elements and nodes configured: */
+	elements->Configure(elements,loads, nodes,vertices, materials,parameters);
+	nodes->Configure(elements,loads, nodes,vertices, materials,parameters);
+	parameters->Configure(elements,loads, nodes,vertices, materials,parameters);
+
+	/*Serialize vector: */
+	VecToMPISerial(&vector_serial,vector);
+
+	/*ok, is the extrusion dependent upon elements or just nodes? If collapse is 1, it means we only want 
+	 * to extrude the vector on elemenets that are collapsed (element operation). If collapse is 0, it means 
+	 * we want to extrude vector on every node (node operation): */
+
+	if(collapse){
+		/*Extrude vector vertically: */
+		for(i=0;i<elements->Size();i++){
+			element=(Element*)elements->GetObjectByOffset(i);
+			if(element->Enum()==PentaEnum){
+				penta=(Penta*)element;
+				penta->VecExtrude(vector,vector_serial,collapse);
+			}
+		}
+	}
+	else{
+		for(i=0;i<nodes->Size();i++){
+			node=(Node*)nodes->GetObjectByOffset(i);
+			node->VecExtrude(vector,vector_serial);
+		}
+	}
+
+	/*Assemble vector: */
+	VecAssemblyBegin(vector);
+	VecAssemblyEnd(vector);
+
+	/*Free ressources:*/
+	xfree((void**)&vector_serial);
+
+}
Index: issm/trunk/src/c/modules/VecExtrudex/VecExtrudex.h
===================================================================
--- issm/trunk/src/c/modules/VecExtrudex/VecExtrudex.h	(revision 4055)
+++ issm/trunk/src/c/modules/VecExtrudex/VecExtrudex.h	(revision 4055)
@@ -0,0 +1,14 @@
+/*!\file:  VecExtrudex.h
+ * \brief header file for field extrusion
+ */ 
+
+#ifndef _VECEXTRUDEX_H
+#define _VECEXTRUDEX_H
+
+#include "../../DataSet/DataSet.h"
+
+/* local prototypes: */
+void VecExtrudex( Vec vector, DataSet* elements,DataSet* nodes, DataSet* vertices, DataSet* loads, DataSet* materials, Parameters* parameters,int collapse);
+
+#endif  /* _VECEXTRUDEX_H */
+
Index: issm/trunk/src/c/modules/modules.h
===================================================================
--- issm/trunk/src/c/modules/modules.h	(revision 4054)
+++ issm/trunk/src/c/modules/modules.h	(revision 4055)
@@ -53,5 +53,5 @@
 #include "./ComputePressurex/ComputePressurex.h"
 #include "./ComputeStrainRatex/ComputeStrainRatex.h"
-#include "./FieldExtrudex/FieldExtrudex.h"
+#include "./VecExtrudex/VecExtrudex.h"
 #include "./Qmux/Qmux.h"
 #include "./NodeConnectivityx/NodeConnectivityx.h"
@@ -81,4 +81,6 @@
 #include "./ScaleInputx/ScaleInputx.h"
 #include "./AXPYInputx/AXPYInputx.h"
+#include "./GetVectorFromInputsx/GetVectorFromInputsx.h"
+#include "./InputConvergencex/InputConvergencex.h"
 
 #endif
Index: issm/trunk/src/c/objects/Elements/Beam.cpp
===================================================================
--- issm/trunk/src/c/objects/Elements/Beam.cpp	(revision 4054)
+++ issm/trunk/src/c/objects/Elements/Beam.cpp	(revision 4055)
@@ -562,15 +562,15 @@
 /*}}}*/
 /*FUNCTION Beam::Gradj{{{1*/
-void  Beam::Gradj(int control_type){
+void  Beam::Gradj(Vec gradient,int control_type){
 	ISSMERROR(" not supported yet!");
 }
 /*}}}*/
 /*FUNCTION Beam::GradjB{{{1*/
-void  Beam::GradjB(void){
+void  Beam::GradjB(Vec gradient){
 	ISSMERROR(" not supported yet!");
 }
 /*}}}*/
 /*FUNCTION Beam::GradjDrag{{{1*/
-void  Beam::GradjDrag(void){
+void  Beam::GradjDrag(Vec gradient){
 	ISSMERROR(" not supported yet!");
 }
@@ -1055,2 +1055,30 @@
 }
 /*}}}*/
+/*FUNCTION Beam::InputConvergence(int* pconverged, double* eps, int* enums,int num_enums,int* criterionenums,double* criterionvalues,int num_criterionenums){{{1*/
+void  Beam::InputConvergence(int* pconverged,double* eps, int* enums,int num_enums,int* criterionenums,double* criterionvalues,int num_criterionenums){a
+
+	Input** new_inputs=NULL;
+	Input** old_inputs=NULL;
+	int     converged=1;
+
+	new_inputs=(Input**)xmalloc(num_enums/2*sizeof(Input*)); //half the enums are for the new inputs
+	old_inputs=(Input**)xmalloc(num_enums/2*sizeof(Input*)); //half the enums are for the old inputs
+	
+	for(i=0;i<num_enums/2;i++){
+		new_inputs[i]=(Input*)this->inputs->GetInput(new_enums[2*i+0]);
+		old_inputs[i]=(Input*)this->inputs->GetInput(old_enums[2*i+1]);
+		if(!new_inputs[i])ISSMERROR("%s%s"," could not find input with enum ",EnumAsString(new_enums[2*i+0]));
+		if(!old_inputs[i])ISSMERROR("%s%s"," could not find input with enum ",EnumAsString(old_enums[2*i+0]));
+	}
+
+	/*ok, we've got the inputs (new and old), now loop throught the number of criterions and fill the eps array:*/
+	for(i=0;i<num_criterionenums;i++){
+		IsInputConverged(eps+i,new_inputs,old_inputs,num_enums/2,,criterionenums[i]);
+		if(eps[i]>criterionvalues[i]) converged=0; 
+	}
+
+	/*Assign output pointers:*/
+	*pconverged=converged;
+
+}
+/*}}}*/
Index: issm/trunk/src/c/objects/Elements/Beam.h
===================================================================
--- issm/trunk/src/c/objects/Elements/Beam.h	(revision 4054)
+++ issm/trunk/src/c/objects/Elements/Beam.h	(revision 4055)
@@ -62,5 +62,5 @@
 		void  UpdateInputsFromConstant(bool constant, int name){ISSMERROR("Not implemented yet!");}
 		void  UpdateInputsFromSolution(double* solution);
-		void  DepthAverageInputAtBase(int enum_type){ISSMERROR("not implemented yet");};
+		void  DepthAverageInputAtBase(int enum_type,int average_enum_type){ISSMERROR("not implemented yet");};
 		void  InputToResult(int enum_type,int step,double time);
 		void   ProcessResultsUnits(void);
@@ -98,4 +98,5 @@
 		void  AXPYInput(int YEnum, double scalar, int XEnum);
 		void  ControlConstrainInput(int control_type,double cm_min, double cm_max);
+		void  InputConvergence(int* enums,int num_enums,int* criterionenums,double* criterionvalues,int num_criterionenums);
 
 		/*}}}*/
@@ -106,7 +107,7 @@
 		void  GetThicknessList(double* thickness_list);
 		void  Du(Vec);
-		void  Gradj(int control_type);
-		void  GradjDrag(void);
-		void  GradjB(void);
+		void  Gradj(Vec gradient,int control_type);
+		void  GradjDrag(Vec gradient);
+		void  GradjB(Vec gradient);
 		double Misfit(void);
 		double SurfaceArea(void);
Index: issm/trunk/src/c/objects/Elements/Element.h
===================================================================
--- issm/trunk/src/c/objects/Elements/Element.h	(revision 4054)
+++ issm/trunk/src/c/objects/Elements/Element.h	(revision 4055)
@@ -37,11 +37,11 @@
 		virtual void   GetBedList(double* bed_list)=0;
 		virtual void   Du(Vec du_g)=0;
-		virtual void   Gradj(int control_type)=0;
-		virtual void   GradjDrag(void)=0;
-		virtual void   GradjB(void)=0;
+		virtual void   Gradj(Vec gradient,int control_type)=0;
+		virtual void   GradjDrag(Vec gradient)=0;
+		virtual void   GradjB(Vec gradient)=0;
 		virtual double Misfit(void)=0;
 		virtual double CostFunction(void)=0;
 		virtual double SurfaceArea(void)=0;
-		virtual void   DepthAverageInputAtBase(int enum_type)=0;
+		virtual void   DepthAverageInputAtBase(int enum_type,int average_enum_type)=0;
 		virtual void   ComputeBasalStress(Vec sigma_b)=0;
 		virtual void   ComputePressure(Vec p_g)=0;
@@ -69,4 +69,6 @@
 		virtual void   AXPYInput(int YEnum, double scalar, int XEnum)=0;
 		virtual void   ControlConstrainInput(int control_type,double cm_min, double cm_max)=0;
+		virtual void   InputConvergence(int* pconverged, double* eps, int* enums,int num_enums,int* criterionenums,double criterionvalues,double* criterionvalues,int num_criterionenums)=0;
+
 		/*Implementation: */
 
Index: issm/trunk/src/c/objects/Elements/Penta.cpp
===================================================================
--- issm/trunk/src/c/objects/Elements/Penta.cpp	(revision 4054)
+++ issm/trunk/src/c/objects/Elements/Penta.cpp	(revision 4055)
@@ -658,5 +658,5 @@
 
 	}
-	else if (analysis_type==SlopeComputeAnalysisEnum){
+	else if (analysis_type==SlopeAnalysisEnum){
 
 		UpdateInputsFromSolutionSlopeCompute( solution);
@@ -1270,5 +1270,5 @@
 		else ISSMERROR("%s%i%s\n","sub_analysis: ",sub_analysis_type," not supported yet");
 	}
-	else if (analysis_type==SlopeComputeAnalysisEnum){
+	else if (analysis_type==SlopeAnalysisEnum){
 		CreateKMatrixSlopeCompute( Kgg);
 	}
@@ -2357,5 +2357,5 @@
 		else ISSMERROR("%s%i%s\n","sub_analysis: ",sub_analysis_type," not supported yet");
 	}
-	else if (analysis_type==SlopeComputeAnalysisEnum){
+	else if (analysis_type==SlopeAnalysisEnum){
 		CreatePVectorSlopeCompute( pg);
 	}
@@ -3263,12 +3263,10 @@
 }
 /*}}}*/
-/*FUNCTION Penta::FieldExtrude {{{1*/
-void  Penta::FieldExtrude(Vec field,double* field_serial,char* field_name, int iscollapsed){
+/*FUNCTION Penta::VecExtrude {{{1*/
+void  Penta::VecExtrude(Vec vector,double* vector_serial,int iscollapsed){
 
 	/* node data: */
-	const int    numgrids=6;
-	int          numberofdofspernode;
+	int   i;
 	Node* node=NULL;
-	int   i;
 	int   extrude=0;
 
@@ -3296,116 +3294,35 @@
 	if(onbed==0)extrude=0;
 
-	/*Go on and extrude field: */
+	/*Go on and extrude vector: */
 	if (extrude){
 
-		if (strcmp(field_name,"velocity")==0){
-
-			/* node data: */
-			const int    numdof=2*numgrids;
-			int          doflist[numdof];
-			int          nodedofs[2];
-			double       fieldel[2];
-
-
-			GetDofList(&doflist[0],&numberofdofspernode);
-
-			/*this penta is a collapsed macayeal. For each node on the base of this penta, 
-			 * we grab the field. Once we know the field, we follow the upper nodes, 
-			 * inserting the same field value into field, until we reach the surface: */
-			for(i=0;i<3;i++){
-
-				node=nodes[i]; //base nodes
-
-				/*get field for this base node: */
-				fieldel[0]=field_serial[doflist[numberofdofspernode*i+0]];
-				fieldel[1]=field_serial[doflist[numberofdofspernode*i+1]];
-
-				//go throfieldn all nodes which sit on top of this node, until we reach the surface, 
-				//and plfield  field in field
-				for(;;){
-
-					node->GetDofList(&nodedofs[0],&numberofdofspernode);
-					VecSetValues(field,1,&nodedofs[0],&fieldel[0],INSERT_VALUES);
-					VecSetValues(field,1,&nodedofs[1],&fieldel[1],INSERT_VALUES);
-
-					if (node->IsOnSurface())break;
-					/*get next node: */
-					node=node->GetUpperNode();
-				}
-			}
-		} //if (strcmp(field_name,"velocity")==0)
-		else if (strcmp(field_name,"gradj")==0){
-
-			/* node data: */
-			int          dof1;
-			double       fieldel;
-
-			/*this penta is a collapsed macayeal. For each node on the base of this penta, 
-			 * we grab the field. Once we know the field, we follow the upper nodes, 
-			 * inserting the same field value into field, until we reach the surface: */
-			for(i=0;i<3;i++){
-
-				node=nodes[i]; //base nodes
+		/* node data: */
+		int          dof1;
+		double       vectorel;
+
+		/*this penta is a collapsed macayeal. For each node on the base of this penta, 
+		 * we grab the vector. Once we know the vector, we follow the upper nodes, 
+		 * inserting the same vector value into vector, until we reach the surface: */
+		for(i=0;i<3;i++){
+
+			node=nodes[i]; //base nodes
+			dof1=node->GetDofList1();
+
+			/*get vector for this base node: */
+			vectorel=vector_serial[dof1];
+
+			//go throvectorn all nodes which sit on top of this node, until we reach the surface, 
+			//and plvector  vector in vector
+			for(;;){
+
 				dof1=node->GetDofList1();
-
-				/*get field for this base node: */
-				fieldel=field_serial[dof1];
-
-				//go throfieldn all nodes which sit on top of this node, until we reach the surface, 
-				//and plfield  field in field
-				for(;;){
-
-					dof1=node->GetDofList1();
-					VecSetValues(field,1,&dof1,&fieldel,INSERT_VALUES);
-
-					if (node->IsOnSurface())break;
-					/*get next node: */
-					node=node->GetUpperNode();
-				}
+				VecSetValues(vector,1,&dof1,&vectorel,INSERT_VALUES);
+
+				if (node->IsOnSurface())break;
+				/*get next node: */
+				node=node->GetUpperNode();
 			}
 		}
-		else if ( 
-					(strcmp(field_name,"thickness")==0) ||
-					(strcmp(field_name,"surface")==0)  ||
-					(strcmp(field_name,"bed")==0)  ||
-					(strcmp(field_name,"slopex")==0)  ||
-					(strcmp(field_name,"slopey")==0)
-				  ){
-
-			/* node data: */
-			const int    numdof=1*numgrids;
-			int          doflist[numdof];
-			int          nodedofs;
-			double       fieldel;
-
-			GetDofList(&doflist[0],&numberofdofspernode);
-
-			/*this penta is on the bed. For each node on the base of this penta, 
-			 * we grab the thickness. Once we know the thickness, we follow the upper nodes, 
-			 * inserting the same thickness value into tg, until we reach the surface: */
-			for(i=0;i<3;i++){
-
-				node=nodes[i]; //base nodes
-
-				/*get velocity for this base node: */
-				fieldel=field_serial[doflist[numberofdofspernode*i+0]];
-
-				//go through all nodes which sit on top of this node, until we reach the surface, 
-				//and pltg  fieldel in field:
-				for(;;){
-
-					node->GetDofList(&nodedofs,&numberofdofspernode);
-					VecSetValues(field,1,&nodedofs,&fieldel,INSERT_VALUES);
-
-					if (node->IsOnSurface())break;
-					/*get next node: */
-					node=node->GetUpperNode();
-				}
-			}
-
-		}
-		else ISSMERROR("%s%s%s"," field ",field_name," not supported yet!");
-
-	} //if (extrude)
+	} 
 }
 /*}}}*/
@@ -3451,5 +3368,5 @@
 /*}}}*/
 /*FUNCTION Penta::DepthAverageInputAtBase{{{1*/
-void  Penta::DepthAverageInputAtBase(int enum_type){
+void  Penta::DepthAverageInputAtBase(int enum_type,int average_enum_type){
 	ISSMERROR("Not implemented yet (see Penta::InputExtrude and Node::FieldDepthAverageAtBase)");
 }
@@ -4555,5 +4472,5 @@
 /*}}}*/
 /*FUNCTION Penta::Gradj {{{1*/
-void  Penta::Gradj(int control_type){
+void  Penta::Gradj(Vec gradient,int control_type){
 
 	/*inputs: */
@@ -4567,8 +4484,8 @@
 
 	if (control_type==DragCoefficientEnum){
-		GradjDrag();
+		GradjDrag(gradient);
 	}
 	else if (control_type=RheologyBEnum){
-		GradjB();
+		GradjB(gradient);
 	}
 	else ISSMERROR("%s%i","control type not supported yet: ",control_type);
@@ -4576,10 +4493,10 @@
 /*}}}*/
 /*FUNCTION Penta::GradjDrag {{{1*/
-void  Penta::GradjDrag(void){
+void  Penta::GradjDrag(Vec gradient){
 
 	int i;
 	Tria* tria=NULL;
 	TriaVertexInput* triavertexinput=NULL;
-	double gradient[6]={0,0,0,0,0,0};
+	double temp_gradient[6]={0,0,0,0,0,0};
 
 	/*inputs: */
@@ -4611,5 +4528,6 @@
 		/*MacAyeal or Pattyn*/
 		tria=(Tria*)SpawnTria(0,1,2); //grids 0, 1 and 2 make the new tria.
-		tria->GradjDrag();
+		tria->GradjDrag(gradient);
+		delete tria;
 	}
 	else if (sub_analysis_type==StokesAnalysisEnum){
@@ -4617,24 +4535,18 @@
 		/*Stokes*/
 		tria=(Tria*)SpawnTria(0,1,2); //grids 0, 1 and 2 make the new tria.
-		tria->GradjDragStokes();
+		tria->GradjDragStokes(gradient);
+		delete tria;
 	}
 	else ISSMERROR("%s%i%s\n","sub_analysis: ",sub_analysis_type," not supported yet");
 
-	/*Now, the tria  has a GradientEnum input. Take it, and make a PentaVertexInput out of it, then delete the tria: */
-	triavertexinput=(TriaVertexInput*)tria->inputs->GetInput(GradientEnum);
-	for(i=0;i<3;i++)gradient[i]=triavertexinput->values[i];
-	this->inputs->AddInput(new PentaVertexInput(GradientEnum,&gradient[0]));
-	
-	delete tria;
 
 }
 /*}}}*/
 /*FUNCTION Penta::GradjB {{{1*/
-void  Penta::GradjB(void){
+void  Penta::GradjB(Vec gradient){
 
 	int i;
 	Tria* tria=NULL;
 	TriaVertexInput* triavertexinput=NULL;
-	double gradient[6]={0,0,0,0,0,0};
 
 	/*inputs: */
@@ -4658,18 +4570,14 @@
 		 * and compute gardj*/
 		tria=(Tria*)SpawnTria(0,1,2); //grids 0, 1 and 2 make the new tria (lower face).
-		tria->GradjB();
+		tria->GradjB(gradient);
+		delete tria;
 	}
 	else{
 		/*B is a 2d field, use MacAyeal(2d) gradient even if it is Stokes or Pattyn*/
 		tria=(Tria*)SpawnTria(0,1,2); //grids 0, 1 and 2 make the new tria (lower face).
-		tria->GradjB();
+		tria->GradjB(gradient);
+		delete tria;
 	}
 	
-	/*Now, the tria  has a GradientEnum input. Take it, and make a PentaVertexInput out of it, then delete the tria: */
-	triavertexinput=(TriaVertexInput*)tria->inputs->GetInput(GradientEnum);
-	for(i=0;i<3;i++)gradient[i]=triavertexinput->values[i];
-	this->inputs->AddInput(new PentaVertexInput(GradientEnum,&gradient[0]));
-	
-	delete tria;
 
 }
@@ -5407,2 +5315,30 @@
 }
 /*}}}*/
+/*FUNCTION Penta::InputConvergence(int* pconverged, double* eps, int* enums,int num_enums,int* criterionenums,double* criterionvalues,int num_criterionenums){{{1*/
+void  Penta::InputConvergence(int* pconverged,double* eps, int* enums,int num_enums,int* criterionenums,double* criterionvalues,int num_criterionenums){a
+
+	Input** new_inputs=NULL;
+	Input** old_inputs=NULL;
+	int     converged=1;
+
+	new_inputs=(Input**)xmalloc(num_enums/2*sizeof(Input*)); //half the enums are for the new inputs
+	old_inputs=(Input**)xmalloc(num_enums/2*sizeof(Input*)); //half the enums are for the old inputs
+	
+	for(i=0;i<num_enums/2;i++){
+		new_inputs[i]=(Input*)this->inputs->GetInput(new_enums[2*i+0]);
+		old_inputs[i]=(Input*)this->inputs->GetInput(old_enums[2*i+1]);
+		if(!new_inputs[i])ISSMERROR("%s%s"," could not find input with enum ",EnumAsString(new_enums[2*i+0]));
+		if(!old_inputs[i])ISSMERROR("%s%s"," could not find input with enum ",EnumAsString(old_enums[2*i+0]));
+	}
+
+	/*ok, we've got the inputs (new and old), now loop throught the number of criterions and fill the eps array:*/
+	for(i=0;i<num_criterionenums;i++){
+		IsInputConverged(eps+i,new_inputs,old_inputs,num_enums/2,,criterionenums[i]);
+		if(eps[i]>criterionvalues[i]) converged=0; 
+	}
+
+	/*Assign output pointers:*/
+	*pconverged=converged;
+
+}
+/*}}}*/
Index: issm/trunk/src/c/objects/Elements/Penta.h
===================================================================
--- issm/trunk/src/c/objects/Elements/Penta.h	(revision 4054)
+++ issm/trunk/src/c/objects/Elements/Penta.h	(revision 4055)
@@ -86,7 +86,7 @@
 		bool   GetOnBed();
 		void  Du(Vec du_gg);
-		void  Gradj(int control_type);
-		void  GradjDrag(void);
-		void  GradjB(void);
+		void  Gradj(Vec gradient,int control_type);
+		void  GradjDrag(Vec gradient);
+		void  GradjB(Vec gradient);
 		double Misfit(void);
 		double SurfaceArea(void);
@@ -110,7 +110,7 @@
 		void  GetParameterDerivativeValue(double* p, double* p_list,double* xyz_list, double* gauss_coord);
 		void  GetNodalFunctions(double* l1l6, double* gauss_coord);
-		void  FieldExtrude(Vec field,double* field_serial,char* field_name, int iscollapsed);
+		void  VecExtrude(Vec vector,double* vector_serial,int iscollapsed);
 		void  InputExtrude(int enum_type);
-		void  DepthAverageInputAtBase(int enum_type);
+		void  DepthAverageInputAtBase(int enum_type,int average_enum_type);
 		void  ComputeBasalStress(Vec sigma_bg);
 		void  ComputePressure(Vec p_gg);
@@ -165,4 +165,5 @@
 		void  AXPYInput(int YEnum, double scalar, int XEnum);
 		void  ControlConstrainInput(int control_type,double cm_min, double cm_max);
+		void  InputConvergence(int* enums,int num_enums,int* criterionenums,double* criterionvalues,int num_criterionenums);
 		void  GetVectorFromInputs(Vec vector,int NameEnum);
 
Index: issm/trunk/src/c/objects/Elements/Sing.cpp
===================================================================
--- issm/trunk/src/c/objects/Elements/Sing.cpp	(revision 4054)
+++ issm/trunk/src/c/objects/Elements/Sing.cpp	(revision 4055)
@@ -383,15 +383,15 @@
 /*}}}*/
 /*FUNCTION Sing::Gradj {{{1*/
-void  Sing::Gradj(int control_type){
+void  Sing::Gradj(Vec gradient,int control_type){
 	ISSMERROR(" not supported yet!");
 }
 /*}}}*/
 /*FUNCTION Sing::GradB {{{1*/
-void  Sing::GradjB(void){
+void  Sing::GradjB(Vec gradient){
 	ISSMERROR(" not supported yet!");
 }
 /*}}}*/
 /*FUNCTION Sing::GradjDrag {{{1*/
-void  Sing::GradjDrag(void){
+void  Sing::GradjDrag(Vec gradient){
 	ISSMERROR(" not supported yet!");
 }
@@ -761,2 +761,30 @@
 }
 /*}}}*/
+/*FUNCTION Sing::InputConvergence(int* pconverged, double* eps, int* enums,int num_enums,int* criterionenums,double* criterionvalues,int num_criterionenums){{{1*/
+void  Sing::InputConvergence(int* pconverged,double* eps, int* enums,int num_enums,int* criterionenums,double* criterionvalues,int num_criterionenums){a
+
+	Input** new_inputs=NULL;
+	Input** old_inputs=NULL;
+	int     converged=1;
+
+	new_inputs=(Input**)xmalloc(num_enums/2*sizeof(Input*)); //half the enums are for the new inputs
+	old_inputs=(Input**)xmalloc(num_enums/2*sizeof(Input*)); //half the enums are for the old inputs
+	
+	for(i=0;i<num_enums/2;i++){
+		new_inputs[i]=(Input*)this->inputs->GetInput(new_enums[2*i+0]);
+		old_inputs[i]=(Input*)this->inputs->GetInput(old_enums[2*i+1]);
+		if(!new_inputs[i])ISSMERROR("%s%s"," could not find input with enum ",EnumAsString(new_enums[2*i+0]));
+		if(!old_inputs[i])ISSMERROR("%s%s"," could not find input with enum ",EnumAsString(old_enums[2*i+0]));
+	}
+
+	/*ok, we've got the inputs (new and old), now loop throught the number of criterions and fill the eps array:*/
+	for(i=0;i<num_criterionenums;i++){
+		IsInputConverged(eps+i,new_inputs,old_inputs,num_enums/2,,criterionenums[i]);
+		if(eps[i]>criterionvalues[i]) converged=0; 
+	}
+
+	/*Assign output pointers:*/
+	*pconverged=converged;
+
+}
+/*}}}*/
Index: issm/trunk/src/c/objects/Elements/Sing.h
===================================================================
--- issm/trunk/src/c/objects/Elements/Sing.h	(revision 4054)
+++ issm/trunk/src/c/objects/Elements/Sing.h	(revision 4055)
@@ -62,5 +62,5 @@
 		void  UpdateInputsFromConstant(bool constant, int name){ISSMERROR("Not implemented yet!");}
 		void  UpdateInputsFromSolution(double* solutiong);
-		void  DepthAverageInputAtBase(int enum_type){ISSMERROR("not implemented yet");};
+		void  DepthAverageInputAtBase(int enum_type,int average_enum_type){ISSMERROR("not implemented yet");};
 		void  InputToResult(int enum_type,int step,double time);
 		void   ProcessResultsUnits(void);
@@ -96,4 +96,5 @@
 		void  ScaleInput(int enum_type,double scale_factor);
 		void  AXPYInput(int YEnum, double scalar, int XEnum);
+		void  InputConvergence(int* enums,int num_enums,int* criterionenums,double* criterionvalues,int num_criterionenums);
 		void  ControlConstrainInput(int control_type,double cm_min, double cm_max);
 
@@ -106,7 +107,7 @@
 		void  GetThicknessList(double* thickness_list);
 		void  Du(Vec);
-		void  Gradj(int control_type);
-		void  GradjDrag(void);
-		void  GradjB(void);
+		void  Gradj(Vec gradient,int control_type);
+		void  GradjDrag(Vec gradient);
+		void  GradjB(Vec gradient);
 		double Misfit(void);
 		double SurfaceArea(void);
Index: issm/trunk/src/c/objects/Elements/Tria.cpp
===================================================================
--- issm/trunk/src/c/objects/Elements/Tria.cpp	(revision 4054)
+++ issm/trunk/src/c/objects/Elements/Tria.cpp	(revision 4055)
@@ -569,5 +569,5 @@
 		else ISSMERROR("%s%i%s\n","sub_analysis: ",sub_analysis_type," not supported yet");
 	}
-	else if (analysis_type==SlopeComputeAnalysisEnum){
+	else if (analysis_type==SlopeAnalysisEnum){
 		UpdateInputsFromSolutionSlopeCompute( solution);
 	}
@@ -979,5 +979,5 @@
 		else ISSMERROR("%s%i%s\n","sub_analysis: ",sub_analysis_type," not supported yet");
 	}
-	else if (analysis_type==SlopeComputeAnalysisEnum){
+	else if (analysis_type==SlopeAnalysisEnum){
 		CreateKMatrixSlopeCompute( Kgg);
 	}
@@ -2394,5 +2394,5 @@
 		else ISSMERROR("%s%i%s\n","sub_analysis: ",sub_analysis_type," not supported yet");
 	}
-	else if (analysis_type==SlopeComputeAnalysisEnum){
+	else if (analysis_type==SlopeAnalysisEnum){
 		CreatePVectorSlopeCompute( pg);
 	}
@@ -4125,5 +4125,5 @@
 /*}}}*/
 /*FUNCTION Tria::Gradj {{{1*/
-void  Tria::Gradj(int control_type){
+void  Tria::Gradj(Vec gradient,int control_type){
 
 	/*inputs: */
@@ -4137,8 +4137,8 @@
 
 	if (control_type==DragCoefficientEnum){
-		GradjDrag();
+		GradjDrag(gradient);
 	}
 	else if (control_type==RheologyBEnum){
-		GradjB();
+		GradjB(gradient);
 	}
 	else ISSMERROR("%s%i","control type not supported yet: ",control_type);
@@ -4146,5 +4146,5 @@
 /*}}}*/
 /*FUNCTION Tria::GradjDrag {{{1*/
-void  Tria::GradjDrag(void){
+void  Tria::GradjDrag(Vec gradient){
 
 
@@ -4295,6 +4295,6 @@
 
 
-	/*Add grade_g to the inputs of this element: */
-	this->inputs->AddInput(new TriaVertexInput(GradientEnum,&grade_g[0]));
+	/*Add grade_g to global vector gradient: */
+	VecSetValues(gradient,numgrids,doflist1,(const double*)grade_g,ADD_VALUES);
 
 	cleanup_and_return: 
@@ -4308,5 +4308,5 @@
 /*}}}*/
 /*FUNCTION Tria::GradjDragStokes {{{1*/
-void  Tria::GradjDragStokes(void){
+void  Tria::GradjDragStokes(Vec gradient){
 
 	int i;
@@ -4465,4 +4465,7 @@
 	}
 
+	/*Add grade_g to global vector gradient: */
+	VecSetValues(gradient,numgrids,doflist1,(const double*)grade_g,ADD_VALUES);
+
 	/*Add grade_g to the inputs of this element: */
 	this->inputs->AddInput(new TriaVertexInput(GradientEnum,&grade_g[0]));
@@ -4478,5 +4481,5 @@
 /*}}}*/
 /*FUNCTION Tria::GradjB{{{1*/
-void  Tria::GradjB(void){
+void  Tria::GradjB(Vec gradient){
 
 	int i;
@@ -4613,6 +4616,6 @@
 	}
 
-	/*Add grade_g to the inputs of this element: */
-	this->inputs->AddInput(new TriaVertexInput(GradientEnum,&grade_g[0]));
+	/*Add grade_g to global vector gradient: */
+	VecSetValues(gradient,numgrids,doflist1,(const double*)grade_g,ADD_VALUES);
 
 	cleanup_and_return: 
@@ -5014,5 +5017,5 @@
 /*}}}*/
 /*FUNCTION Tria::DepthAverageInputAtBase {{{1*/
-void  Tria::DepthAverageInputAtBase(int enum_type){
+void  Tria::DepthAverageInputAtBase(int enum_type,int average_enum_type){
 
 	/*New input*/
@@ -5026,17 +5029,5 @@
 
 	/*Assign new name (average)*/
-	switch(enum_type){
-
-		case VxEnum:
-			newinput->ChangeEnum(VxAverageEnum);
-			break;
-
-		case VyEnum:
-			newinput->ChangeEnum(VyAverageEnum);
-			break;
-
-		default:
-			ISSMERROR("enum_type: %i (%s) not suppoerted yet",enum_type,EnumAsString(enum_type));
-	}
+	newinput->ChangeEnum(average_enum_type);
 
 	/*Add new input to current element*/
@@ -5503,2 +5494,30 @@
 }
 /*}}}*/
+/*FUNCTION Tria::InputConvergence(int* pconverged, double* eps, int* enums,int num_enums,int* criterionenums,double* criterionvalues,int num_criterionenums){{{1*/
+void  Tria::InputConvergence(int* pconverged,double* eps, int* enums,int num_enums,int* criterionenums,double* criterionvalues,int num_criterionenums){a
+
+	Input** new_inputs=NULL;
+	Input** old_inputs=NULL;
+	int     converged=1;
+
+	new_inputs=(Input**)xmalloc(num_enums/2*sizeof(Input*)); //half the enums are for the new inputs
+	old_inputs=(Input**)xmalloc(num_enums/2*sizeof(Input*)); //half the enums are for the old inputs
+	
+	for(i=0;i<num_enums/2;i++){
+		new_inputs[i]=(Input*)this->inputs->GetInput(new_enums[2*i+0]);
+		old_inputs[i]=(Input*)this->inputs->GetInput(old_enums[2*i+1]);
+		if(!new_inputs[i])ISSMERROR("%s%s"," could not find input with enum ",EnumAsString(new_enums[2*i+0]));
+		if(!old_inputs[i])ISSMERROR("%s%s"," could not find input with enum ",EnumAsString(old_enums[2*i+0]));
+	}
+
+	/*ok, we've got the inputs (new and old), now loop throught the number of criterions and fill the eps array:*/
+	for(i=0;i<num_criterionenums;i++){
+		IsInputConverged(eps+i,new_inputs,old_inputs,num_enums/2,,criterionenums[i]);
+		if(eps[i]>criterionvalues[i]) converged=0; 
+	}
+
+	/*Assign output pointers:*/
+	*pconverged=converged;
+
+}
+/*}}}*/
Index: issm/trunk/src/c/objects/Elements/Tria.h
===================================================================
--- issm/trunk/src/c/objects/Elements/Tria.h	(revision 4054)
+++ issm/trunk/src/c/objects/Elements/Tria.h	(revision 4055)
@@ -55,5 +55,5 @@
 		int   MyRank(void);
 		void  SetClone(int* minranks);
-		void  DepthAverageInputAtBase(int enum_type);
+		void  DepthAverageInputAtBase(int enum_type,int average_enum_type);
 		void*  SpawnSing(int g0);
 		void*  SpawnBeam(int g0, int g1);
@@ -88,8 +88,8 @@
 		void  GetJacobian(double* J, double* xyz_list,double* gauss_l1l2l3);
 		void  Du(Vec du_g);
-		void  Gradj(int control_type);
-		void  GradjDrag(void);
-		void  GradjDragStokes(void);
-		void  GradjB(void);
+		void  Gradj(Vec gradient,int control_type);
+		void  GradjDrag(Vec gradient);
+		void  GradjDragStokes(Vec gradient);
+		void  GradjB(Vec gradient);
 		void  SurfaceNormal(double* surface_normal, double xyz_list[3][3]);
 		double Misfit(void);
@@ -142,4 +142,5 @@
 		void  ScaleInput(int enum_type,double scale_factor);
 		void  AXPYInput(int YEnum, double scalar, int XEnum);
+		void  InputConvergence(int* enums,int num_enums,int* criterionenums,double* criterionvalues,int num_criterionenums);
 		void  ControlConstrainInput(int control_type,double cm_min, double cm_max);
 		void  GetVectorFromInputs(Vec vector,int NameEnum);
